/*
 * Created on 23.06.2005 for PIROL
 *
 * SVN header information:
 *  $Author: LBST-PF-3\orahn $
 *  $Rev: 2446 $
 *  $Date: 2006-09-12 14:57:25 +0200 (Di, 12 Sep 2006) $
 *  $Id: ConstantValue.java 2446 2006-09-12 12:57:25Z LBST-PF-3\orahn $
 */
package de.fhOsnabrueck.jump.pirol.utilities.FormulaParsing.Values;

import com.vividsolutions.jump.feature.Feature;

import de.fhOsnabrueck.jump.pirol.utilities.FormulaParsing.FormulaValue;

/**
 * A simple value class that just stores a constant value.
 *
 * @author Ole Rahn
 * <br>
 * <br>FH Osnabr&uuml;ck - University of Applied Sciences Osnabr&uuml;ck,
 * <br>Project: PIROL (2005),
 * <br>Subproject: Daten- und Wissensmanagement
 * 
 * @version $Rev: 2446 $
 * 
 */
public class ConstantValue extends FormulaValue {
    
    protected double value;

    public ConstantValue(double value) {
        super();
        this.value = value;
    }
    
    /**
     *@param feature in this case we don't need the feature...
     *@return the constant value
     */
    public double getValue(Feature feature) {
        return this.value;
    }
    
    /**
     * @inheritDoc
     */
    public boolean isFeatureDependent() {
        return false;
    }
    
    /**
     * @inheritDoc
     */
    public String toString(){
        return "" + this.value;
    }

}
