/*
 * Created on 07.12.2004
 *
 * SVN header information:
 *  $Author: LBST-PF-3\orahn $
 *  $Rev: 2451 $
 *  $Date: 2006-09-12 15:07:53 +0200 (Di, 12 Sep 2006) $
 *  $Id: featureSorter.java 2451 2006-09-12 13:07:53Z LBST-PF-3\orahn $
 */
package de.fhOsnabrueck.jump.pirol.utilities.comparisonAndSorting;

import java.util.ArrayList;
import java.util.Collections;
import java.util.List;

import com.vividsolutions.jump.feature.Feature;

import de.fhOsnabrueck.jump.pirol.utilities.apiTools.FeatureCollectionTools;
import de.fhOsnabrueck.jump.pirol.utilities.graph.xCoordinateComparableFeature;
;

/**
 * Class to sort an array of Features using 
 * objects that are sortable wrappers for features.
 * 
 * @author Ole Rahn
 * <br>
 * <br>FH Osnabr&uuml;ck - University of Applied Sciences Osnabr&uuml;ck,
 * <br>Project: PIROL (2005),
 * <br>Subproject: Daten- und Wissensmanagement
 * 
 * @version $Rev: 2451 $
 */
public class featureSorter {

	public static List sortByFid( List<Feature> features ){
	    ArrayList<ComparableById> tmp = new ArrayList<ComparableById>();
	    
	    Feature[] featureArray = FeatureCollectionTools.FeatureCollection2FeatureArray(features);
		
	    for ( int i=0; i<featureArray.length; i++){
			tmp.add(new ComparableById(featureArray[i]));
		}
		
		Collections.sort(tmp);
		
		ArrayList<Feature> result = new ArrayList<Feature>();
		
		ComparableById[] tmp_Array = (ComparableById[])tmp.toArray(new ComparableById[0]);
		
		for ( int i=0; i<tmp.size(); i++){
			result.add( tmp_Array[i].getFeature() );
		}
		
		return result;
		
	}
	
	public static List sortByX( List<Feature> features ){
	    ArrayList<Comparable> tmp = new ArrayList<Comparable>();
		
	    Feature[] featureArray = FeatureCollectionTools.FeatureCollection2FeatureArray(features);
	    
		for ( int i=0; i<featureArray.length; i++){
			tmp.add(new de.fhOsnabrueck.jump.pirol.utilities.graph.xCoordinateComparableFeature(featureArray[i]));
		}
		
		Collections.sort(tmp);
		
		ArrayList<Feature> result = new ArrayList<Feature>();
		
		xCoordinateComparableFeature[] tmp_Array = (xCoordinateComparableFeature[])tmp.toArray(new xCoordinateComparableFeature[0]);
		
		for ( int i=0; i<tmp.size(); i++){
			result.add( tmp_Array[i].getFeature() );
		}
		
		return result;
		
	}
	
}
