/*
 * Created on 19.05.2005 for PIROL
 *
 * SVN header information:
 *  $Author: LBST-PF-3\orahn $
 *  $Rev: 2446 $
 *  $Date: 2006-09-12 14:57:25 +0200 (Di, 12 Sep 2006) $
 *  $Id: StandardPirolCorrelationPlugIn.java 2446 2006-09-12 12:57:25Z LBST-PF-3\orahn $
 */
package de.fhOsnabrueck.jump.pirol.utilities.plugIns;

import de.fhOsnabrueck.jump.pirol.utilities.debugOutput.PersonalLogger;


/**
 * 
 * PlugIn base class for PlugIns that deal with correlations.
 *
 * @author Ole Rahn
 * <br>
 * <br>FH Osnabr&uuml;ck - University of Applied Sciences Osnabr&uuml;ck,
 * <br>Project: PIROL (2005),
 * <br>Subproject: Daten- und Wissensmanagement
 * 
 * @version $Rev: 2446 $
 *
 */
public abstract class StandardPirolCorrelationPlugIn extends StandardPirolPlugIn {
    


    public StandardPirolCorrelationPlugIn(PersonalLogger logger) {
        super(logger);
        this.useToolIconSize = true;
    }

    /**
     * For HTML-output: this methods returns a color (as a String) that gives an
     * impression on how strong the correlation (given by the correlation coefficient) is.
     *@param coefficient the correlation coefficient
     *@return green (if correlation is strong), orange (if it's there, but not too strong), red (if it's not there)
     */
    protected String getColorStringforCorrelationCoefficient(double coefficient){
        if (Math.abs(coefficient) >= 0.75)
            return "#00ff00";
        else if (Math.abs(coefficient) >= 0.5)
            return "#dd9900";
        else
            return "red";
    }

}
